#pragma once

#include <ft2build.h>
#include <freetype/freetype.h>	/* FT_FREETYPE_H */
#include <freetype/ftcache.h>	/* FT_CACHE_H */

class FreeTypeFontEngine;
extern FreeTypeFontEngine* g_pFTEngine;

enum FT_EngineConstants {
	FT_MAX_CHARS	= 65536,
};

/*
  FreeTypeɕAAΑ̂LbV@\̂ł₤

  1. ܂DllMain(DLL_PROCESS_ATTACH)FreeTypeFontEnginẽCX^XB
     (ԂCGdiPPSettingsFontLInit(FreeType)FreeTypeFontEnginetbN)
     ForceChangeFontŏB

  2. CreateFontFreeTypeFontEngine::AddFontĂяoAFreeTypeFontInfo
     tHgтB
     łFreeTypeFontInfoIndividual̐ݒRs[ĎB

  3. ExtTextOutGetTextExtentȂǂFreeTypePrepare֐Ăяo
     ɓFreeTypeFontInfo::GetCacheĂяoAtHgTCYȂǂ
     FreeTypeFontCache𓾂BΐB
     FreeTypeFontCache͓FreeTypeCharDatãe[u(UCS2Ȃ̂2^16)
     ĂāAFreeTypeCharDataɂ͕ɃLbVf[^ۊǂB

  4. FreeTypeFontCacheA܂̓OtԍFreeTypeCharData𓾂B
     LbV(ɎcĂ)AMRUJE^ZbgB
     ꍇ͈UX[AAddCharDataŃLbVǉB

  5. ǉ܂ƃ炤̂ŁAǉ萔(FREETYPE_REQCOUNTMAX)𒴂
     GChLōŋߎQƂꂽLbVf[^FREETYPE_GC_COUNTERcA
     ȊÕf[^(FreeTypeCharData)͊JB
     2̒萔iniŐݒύXł悤ȋCB

  6. ŌɁADllMain(DLL_PROCESS_DETACH)FreeTypeFontEnginẽCX^XjA
     SẴLbVJB

 */

class FreeTypeGCCounter
{
private:
	int m_addcount;		//ǉp
	int m_mrucount;		//MRUp

public:
	FreeTypeGCCounter()
		: m_addcount(0), m_mrucount(0)
	{
	}
	int AddIncrement() { return ++m_addcount; }
	int MruIncrement() { return ++m_mrucount; }

	void ResetGCCounter()
	{
		m_mrucount = 0;
		m_addcount = 0;
	}
};

class FreeTypeMruCounter
{
private:
	int m_mrucounter;	//GCp

public:
	FreeTypeMruCounter(int n)
		: m_mrucounter(n)
	{
	}

	//GCpMRUJE^
	int GetMruCounter() const { return m_mrucounter; }
	void ResetMruCounter() { m_mrucounter = 0; }
	void SetMruCounter(FreeTypeGCCounter* p) { m_mrucounter = p->MruIncrement(); }
};

//A(glyph index)AFT_BitmapGlyph(AΑ̂̂)LbV
class FreeTypeCharData : public FreeTypeMruCounter
{
private:
	typedef CValArray<FreeTypeCharData**>	CharDataArray;
	CharDataArray		m_arrSelfChar;	//g̕ۑ(Char)
	FreeTypeCharData**	m_ppSelfGlyph;	//(Glyph)
	UINT				m_glyphindex;	//Otԍ
	int					m_width;		//
	FT_BitmapGlyph		m_glyph;		//J[p
	FT_BitmapGlyph		m_glyphMono;	//mNp
	int					m_bmpSize;		//rbg}bvTCY
	int					m_bmpMonoSize;	// V
//	LONG				m_refcounter;	//QƃJE^

#ifdef _DEBUG
	WCHAR				m_wch;			//UCS2
#endif
	NOCOPY(FreeTypeCharData);

	//FT_Bitmap::buffer̃TCYԂ
	static inline int FT_Bitmap_CalcSize(FT_BitmapGlyph gl)
	{
		return gl->bitmap.pitch * gl->bitmap.rows;
	}

public:
	FreeTypeCharData(FreeTypeCharData** ppCh, FreeTypeCharData** ppGl, WCHAR wch, UINT glyphindex, int width, int mru);
	~FreeTypeCharData();

#ifdef _DEBUG
	WCHAR GetChar() const { return m_wch; }
#else
	WCHAR GetChar() const { return L'?'; }
#endif
	UINT GetGlyphIndex() const { return m_glyphindex; }
	int GetWidth() const { return m_width; }

	void AddChar(FreeTypeCharData** ppCh)
	{
		if (ppCh)
			m_arrSelfChar.Add(ppCh);
	}
	FT_BitmapGlyph GetGlyph(FT_Render_Mode render_mode) const
	{
		return (render_mode == FT_RENDER_MODE_MONO) ? m_glyphMono : m_glyph;
	}
	void SetGlyph(FT_Render_Mode render_mode, FT_BitmapGlyph glyph);

	void Erase()
	{
		delete this;
	}
};

class FreeTypeFontCache : public FreeTypeMruCounter, public FreeTypeGCCounter
{
private:
	int  m_px;
	int  m_weight;
	bool m_italic;
	bool m_active;
	TEXTMETRIC m_tm;

	//4~65536~2512KB炢mĂ̂ŌŒzŖ薳
	FreeTypeCharData*	m_chars[FT_MAX_CHARS];
	FreeTypeCharData*	m_glyphs[FT_MAX_CHARS];

	NOCOPY(FreeTypeFontCache);
	void Compact();

	FreeTypeCharData** _GetChar(WCHAR wch)
	{
		return m_chars + wch;
	}
	FreeTypeCharData** _GetGlyph(UINT glyph)
	{
		return m_glyphs + glyph;
	}

public:
	FreeTypeFontCache(int px, int weight, bool italic, int mru);
	~FreeTypeFontCache();

	const TEXTMETRIC& GetTextMetric(HDC hdc)
	{
		if (m_tm.tmHeight == 0) {
			::GetTextMetrics(hdc, &m_tm);
		}
		return m_tm;
	}

	bool Equals(int px, int weight, bool italic) const
	{
		return (m_px == px && m_weight == weight && m_italic == italic);
	}
	FreeTypeCharData* FindChar(WCHAR wch)
	{
		FreeTypeCharData* p = *_GetChar(wch);
		if(p) {
			p->SetMruCounter(this);
		}
		return p;
	}

	FreeTypeCharData* FindGlyphIndex(UINT glyph)
	{
		FreeTypeCharData* p = (glyph & 0xffff0000) ? NULL : *_GetGlyph(glyph);
		if(p) {
			p->SetMruCounter(this);
		}
		return p;
	}

	bool Activate()
	{
		if (!m_active) {
			m_active = true;
			return true;
		}
		return false;
	}

	void Erase();
	void AddCharData(WCHAR wch, UINT glyphindex, int width, FT_BitmapGlyph glyph, FT_Render_Mode render_mode);
	void AddGlyphData(UINT glyphindex, int width, FT_BitmapGlyph glyph, FT_Render_Mode render_mode);
};


// tHgFaceID(intgƂɂ)
class FreeTypeFontInfo : public FreeTypeMruCounter, public FreeTypeGCCounter
{
private:
	int  m_id;
	int  m_weight;
	bool m_italic;
	int  m_ftWeight;
	int  m_nMaxSizes;
	CFontSettings m_set;
	StringHashFont m_hash;
	typedef CArray<FreeTypeFontCache*>	CacheArray;
	CacheArray m_cache;

	NOCOPY(FreeTypeFontInfo);
	void Compact();

public:
	FreeTypeFontInfo(int n, LPCTSTR name, int weight, bool italic, const CFontSettings& set, int mru)
		: m_id(n), m_weight(weight), m_italic(italic), m_hash(name)
		, FreeTypeMruCounter(mru)
	{
		m_set = set;
		m_ftWeight = CalcBoldWeight(weight);

		enum { FTC_MAX_SIZES_DEFAULT = 4 };
		m_nMaxSizes = g_pSettings->CacheMaxSizes();
		if (!m_nMaxSizes)
			m_nMaxSizes = FTC_MAX_SIZES_DEFAULT;
	}
	~FreeTypeFontInfo()
	{
		Erase();
	}

	int CalcNormalWeight() const
	{
		return m_set.GetNormalWeight();
	}
	int CalcBoldWeight(int weight) const
	{
//		return weight - FW_NORMAL) / 8;
//		return ((weight - FW_NORMAL) / 12) + (m_set.GetBoldWeight() << 2);
		if (weight <= FW_NORMAL) {
			return 0;
		}
		return ((weight - FW_NORMAL) / 8) + (m_set.GetBoldWeight() << 2);
	}
	int CalcBoldWeight(const LOGFONT& lf) const
	{
		return CalcBoldWeight(lf.lfWeight);
	}
	void CalcItalicSlant(FT_Matrix& matrix) const
	{
		matrix.xx = 1 << 16;
//		matrix.xy = 0x5800;
		matrix.xy = (5 + m_set.GetItalicSlant()) << 12;
		matrix.yx = 0;
		matrix.yy = 1 << 16;
	}

	bool Equals(const StringHashFont& hash, int weight, bool italic) const
	{
		weight = CalcBoldWeight(weight);
		return (m_ftWeight == weight && m_italic == italic && m_hash == hash);
	}

	int GetId() const { return m_id; }
	LPCTSTR GetName() const { return m_hash.c_str(); }
	int GetFontWeight() const { return m_weight; }
	int GetFTWeight() const { return m_ftWeight; }
	bool IsItalic() const { return m_italic; }
	const StringHashFont& GetHash() const { return m_hash; }

	const CFontSettings& GetFontSettings() const { return m_set; }
	bool operator ==(const FreeTypeFontInfo& x) const { return (m_hash == x.m_hash); }

	FreeTypeFontCache* GetCache(int px, const LOGFONT& lf);

	void Erase()
	{
		CArray<FreeTypeFontCache*>& arr = m_cache;
		int n = arr.GetSize();
		while (n-- > 0) {
			delete arr[n];
			arr[n] = NULL;
		}
		arr.RemoveAll();
	}
};

class FreeTypeFontEngine : public FreeTypeGCCounter
{
private:
	typedef CArray<FreeTypeFontInfo*>	FontListArray;
	FontListArray	m_arrFontList;
	int				m_nMaxFaces;
	int				m_nMemUsed;

	void Compact();

public:
	FreeTypeFontEngine()
		: m_nMemUsed(0), m_nMaxFaces(0)
	{
		enum { FTC_MAX_FACES_DEFAULT = 2 };
		m_nMaxFaces = g_pSettings->CacheMaxFaces();
		if (m_nMaxFaces == 0)
			m_nMaxFaces = FTC_MAX_FACES_DEFAULT;

		//tHg
		LPCTSTR lpszFace = g_pSettings->GetForceFontName();
		if (lpszFace)
			AddFont(lpszFace, FW_NORMAL, false);
	}
	~FreeTypeFontEngine()
	{
		TRACE(_T("MaxFaces: %d\n"), m_arrFontList.GetSize());
		TRACE(_T("MemUsed : %d\n"), m_nMemUsed);
		FontListArray& arr = m_arrFontList;
		int n = arr.GetSize();
		while (n--)
			delete arr[n];
	}

	bool AddFont(LPCTSTR lpFaceName, int weight, bool italic);
	int  GetFontIdByName(LPCTSTR lpFaceName, int weight, bool italic);
//	LPCTSTR GetFontById(int faceid, int& weight, bool& italic);
	FreeTypeFontInfo* FindFont(LPCTSTR lpFaceName, int weight, bool italic);
	FreeTypeFontInfo* FindFont(int faceid);

	bool FontExists(LPCTSTR lpFaceName, int weight, bool italic)
	{
		return !!FindFont(lpFaceName, weight, italic);
	}

	//gpʃJE^
	void AddMemUsed(int x)
	{
		m_nMemUsed += x;
	}
	void SubMemUsed(int x)
	{
		m_nMemUsed -= x;
		if (m_nMemUsed < 0)
			m_nMemUsed = 0;
	}
	template <class T>
	void AddMemUsedObj(T* p)
	{
		AddMemUsed(sizeof(T));
	}
	template <class T>
	void SubMemUsedObj(T* p)
	{
		SubMemUsed(sizeof(T));
	}
};


//GetFontDatãXg[
class FreeTypeSysFontData
{
private:
	HDC		m_hdc;
	HFONT	m_hOldFont;
	bool	m_isTTC;
	bool	m_locked;
	void*	m_pMapping;
	DWORD	m_dwSize;
	FT_Face	m_ftFace;
	FT_StreamRec m_ftStream;

	FreeTypeSysFontData()
		: m_hdc(NULL)
		, m_hOldFont(NULL)
		, m_isTTC(false)
		, m_locked(false)
		, m_pMapping(NULL)
		, m_dwSize(0)
		, m_ftFace(NULL)
	{
		ZeroMemory(&m_ftStream, sizeof(FT_StreamRec));
	}

	static unsigned long IoFunc(FT_Stream stream, unsigned long offset, unsigned char* buffer, unsigned long count);
	static void CloseFunc(FT_Stream  stream);
	bool OpenFaceByIndex(int index);
	bool Init(LPCTSTR name, int weight, bool italic);

public:
	static FreeTypeSysFontData* CreateInstance(LPCTSTR name, int weight, bool italic);
	~FreeTypeSysFontData()
	{
		if (m_pMapping) {
			UnmapViewOfFile(m_pMapping);
		}
		if (m_hOldFont) {
			DeleteFont(SelectFont(m_hdc, m_hOldFont));
		}
		if (m_hdc) {
			DeleteDC(m_hdc);
		}
	}

	FT_Face GetFace()
	{
		FT_Face face = m_ftFace;
		m_ftFace = NULL;
		return face;
	}
};
